LArSoft - Bug #23457

LArReco Calorimetry module places absolute cut on z position which is not detector independent
10/21/2019 02:52 PM - Tracy Usher

Status: Closed Start date: 10/21/2019
Assignee: Gianluca Petrillo % Done: 100%
Target version: Spent time: 0.00 hour

Occurs In: Co-Assignees: Christian Farnese, Gianluca Petrillo
Experiment: ICARUS

Description

Christian Farnese is studying calorimetry with the ICARUS detector and reports the following problem:
... | am slowly proceeding on the studies | presented during the last Monday meeting related to dEdx evaluation...

in particular | am now trying to prepare a code that use the dE/dx measurement for the calibration of the detector: so | use a
large number of cosmic muon tracks to evaluate channel by channel the dE/dx... but | discover something strange: the dE/dx
was calculated only for the collection channel exceeding something like 2000... debugging in icaruscode | understand that there
cut was not on the channel number but in the z coordinate... debugging outside icaruscode (installing in particular larreco) |
discover that if you look to line 373 of the Calorimetry module in larreco

https://nusoft.fnal.gov/larsoft/doxsvn/html/Calorimetry__module_8cc_source.html

there is a cut on z at -100, that is clearly a problem for us (our z coordinate arrive to ~ -900)... it seems that removing that line,
the problem | found is solved! You can find also just the result on 10 cosmic events: in blu the z coordinate of the 3D points with
a dE/dx evaluated before removing the line | mentioned while in red you can see the additional points obtatined removing the
line...

Indeed, if one looks at line 373 of the module one see:

if (xyz3d[2]<-100) continue

The commit messaging implies this line appeared as something related to MicroBooNE where z=0 is at the edge of the TPC, not the
center. For ICARUS z=0 is in the center, this line essentially eliminates nearly half the active volume.

I'm assigning to Gianluca since | believe he has already a solution...

Associated revisions

Revision 30baf419 - 10/21/2019 03:49 PM - Gianluca Petrillo

Make the cut on trajectory point position configurable.

In addition, make more extreme the value of some extreme constants that were not that extreme after all.
This solves LArSoft issue #23457.

Revision d189c4ca - 10/21/2019 04:48 PM - Gianluca Petrillo

Making the cut on trajectory point position optional.

This solves issue #23457.

History

#1 - 10/21/2019 03:43 PM - Tingjun Yang

| think | added that line when we first wrote the module for ArgoNeuT to ignore badly reconstructed points. Since most of the LArTPCs starts from z =
0, we have not had a problem with it yet.

| think the track reconstruction is mature enough that we don't need that check any more. If it causes problems for ICARUS, it should be removed.
#2 - 10/21/2019 03:45 PM - Tracy Usher
Thanks!

#3 - 10/21/2019 03:55 PM - Gianluca Petrillo
- % Done changed from 0 to 90
- Status changed from New to Work in progress

- Co-Assignees Gianluca Petrillo added

A fix is pushed in larreco branch feature/gp_lssue23457 for testing.
The relevant commit is larreco:30baf419.

A new configuration parameter is introduced for Calorimetry module: NotOnTrackZcut (default to -100.0 for backward compatibility) excludes all points
with z smaller that the parameter value.

Another change is the change of some "magic" invalid values from -1000 to std::numeric_limit<double>::lowest(): 1000 cm (10 m) is not so out of the
world for ICARUS.

#4 - 10/21/2019 03:57 PM - Gianluca Petrillo

- Description updated

#5 - 10/21/2019 03:59 PM - Gianluca Petrillo

After Tingjun comment, we should consider to turn the default value to not to apply that cut at all.
But | would like an all clear from the experiments before doing that.

#6 - 10/21/2019 04:55 PM - Gianluca Petrillo

After having received approval by e-mail by Tingjun and Tracy, | am pushing a change to make this cut optional.
If can be restored in its past glory adding to the configuration of the module:

NotOnTrackZcut: -100.0
New commit is larreco:d189c4ca, still in larreco branch feature/gp_Issue23457.

This definitely makes it a breaking change.

#7 - 10/21/2019 06:08 PM - Gianluca Petrillo
- % Done changed from 90 to 100

- Status changed from Work in progress to Resolved

#8 - 10/28/2019 10:27 AM - Lynn Garren

- Status changed from Resolved to Closed

This is in larsoft vO8_33_00

11/02/2020 22


https://cdcvs.fnal.gov/redmine/projects/larreco/repository/revisions/30baf41911c091aff1eb40230d5ae13a512b5058
https://cdcvs.fnal.gov/redmine/projects/larreco/repository/revisions/d189c4ca9c124b209508b83e65b88c4e99f1752a
http://www.tcpdf.org

